//=============================================================================
//
// file :         KChannelSwitchClass.h
//
// description :  Include for the KChannelSwitchClass root class.
//                This class is the singleton class for
//                the KChannelSwitch device class.
//                It contains all properties and methods which the 
//                KChannelSwitch requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: xavela $
//
// $Revision: 1.2 $
// $Date: 2012-05-15 10:06:44 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /users/chaize/newsvn/cvsroot/Instrumentation/KChannelSwitch/src/KChannelSwitchClass.h,v $
// $Log: not supported by cvs2svn $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _KCHANNELSWITCHCLASS_H
#define _KCHANNELSWITCHCLASS_H

#include <tango.h>
#include <KChannelSwitch.h>


namespace KChannelSwitch_ns
{//=====================================
//	Define classes for attributes
//=====================================
class inputChannelNumberAttrib: public Tango::Attr
{
public:
	inputChannelNumberAttrib():Attr("inputChannelNumber", Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~inputChannelNumberAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<KChannelSwitch *>(dev))->read_inputChannelNumber(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<KChannelSwitch *>(dev))->write_inputChannelNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<KChannelSwitch *>(dev))->is_inputChannelNumber_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class OpenAllChannelsCmd : public Tango::Command
{
public:
	OpenAllChannelsCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OpenAllChannelsCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OpenAllChannelsCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<KChannelSwitch *>(dev))->is_OpenAllChannels_allowed(any);}
};



class CloseAllChannelsClass : public Tango::Command
{
public:
	CloseAllChannelsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CloseAllChannelsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CloseAllChannelsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<KChannelSwitch *>(dev))->is_CloseAllChannels_allowed(any);}
};



//
// The KChannelSwitchClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	KChannelSwitchClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static KChannelSwitchClass *init(const char *);
	static KChannelSwitchClass *instance();
	~KChannelSwitchClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	KChannelSwitchClass(string &);
	static KChannelSwitchClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace KChannelSwitch_ns

#endif // _KCHANNELSWITCHCLASS_H
